diff -uNr mythtv-0.21/libs/libmythtv/DVDRingBuffer.cpp mythtv/libs/libmythtv/DVDRingBuffer.cpp
--- mythtv-0.21/libs/libmythtv/DVDRingBuffer.cpp	2008-03-08 22:05:09.000000000 +0100
+++ mythtv/libs/libmythtv/DVDRingBuffer.cpp	2008-05-12 05:08:03.000000000 +0200
@@ -29,21 +29,24 @@
       dvdFilename(NULL),
       dvdBlockRPos(0),  dvdBlockWPos(0),
       pgLength(0),      pgcLength(0),
-      cellStart(0),     pgStart(0),
+      cellStart(0),     cellChanged(false),
+      pgcLengthChanged(false), pgStart(0),
       currentpos(0),
       lastNav(NULL),    part(0),
       title(0),         titleParts(0),
       gotStop(false),
-      cellHasStillFrame(false), dvdWaiting(false),
-      titleLength(0), hl_startx(0), hl_width(0),
-      hl_starty(0), hl_height(0),
+      cellHasStillFrame(false), audioStreamsChanged(false),
+      dvdWaiting(false),
+      titleLength(0), hl_button(0, 0, 0, 0),
+      menuSpuPkt(0),
       menuBuflength(0),
       skipstillorwait(true),
       cellstartPos(0), buttonSelected(false), 
       buttonExists(false), cellid(0), 
       lastcellid(0), vobid(0), 
       lastvobid(0), cellRepeated(false), 
-      buttonstreamid(0), gotoCellStart(false), 
+      buttonstreamid(0), runningCellStart(false), 
+      runSeekCellStart(false),
       menupktpts(0), curAudioTrack(0),
       curSubtitleTrack(0), autoselectaudio(true),
       autoselectsubtitle(true), 
@@ -55,6 +58,10 @@
       parent(0)
 {
     memset(&dvdMenuButton, 0, sizeof(AVSubtitle));
+    memset(dvdBlockWriteBuf, 0, sizeof(char) * DVD_BLOCK_SIZE);
+    memset(clut, 0, sizeof(uint32_t) * 16);
+    memset(button_color, 0, sizeof(uint8_t) * 4);
+    memset(button_alpha, 0, sizeof(uint8_t) * 4);
     uint def[8] = { 3, 5, 10, 20, 30, 60, 120, 180 };
     uint seekValues[8] = { 1, 2, 4, 8, 10, 15, 20, 60 };
 
@@ -80,9 +87,9 @@
 
 bool DVDRingBufferPriv::IsInMenu(void) const
 {
-    return ((title == 0) || 
-            ((pgcLength/90000) < 30) ||
-            (NumMenuButtons() > 0));
+    if (dvdnav)
+        return (!dvdnav_is_domain_vts(dvdnav));
+    return true;
 }
 
 long long DVDRingBufferPriv::NormalSeek(long long time)
@@ -119,8 +126,9 @@
     {
         VERBOSE(VB_PLAYBACK, LOC_ERR + 
                 QString("Seek() to time %1 failed").arg(time));
+        return -1;
     }
-    else if (!IsInMenu() && !gotoCellStart)
+    else if (!IsInMenu() && !runningCellStart)
     {
         gotStop = false;
         if (time > 0 && ffrewSkip == 1)
@@ -274,9 +282,12 @@
                 dvdnav_cell_change_event_t *cell_event =
                     (dvdnav_cell_change_event_t*) (blockBuf);
                 pgLength  = cell_event->pg_length;
+                if (pgcLength != cell_event->pgc_length)
+                    pgcLengthChanged = true;
                 pgcLength = cell_event->pgc_length;
                 cellStart = cell_event->cell_start;
                 pgStart   = cell_event->pg_start;
+                cellChanged = true;
 
                 if (dvdnav_get_next_still_flag(dvdnav) > 0)
                 {
@@ -306,10 +317,10 @@
                             .arg(title).arg(part).arg(titleParts));
 
                 buttonSelected = false;
-                if (gotoCellStart)
+                if (runningCellStart)
                 {
                     lastvobid = lastcellid = 0;
-                    gotoCellStart = false;
+                    runningCellStart = false;
                 }
                 else
                 {
@@ -355,7 +366,10 @@
                 subTrackMap.clear();
                 uint count = dvdnav_subp_get_stream_count(dvdnav);
 
-                ClearMenuSPUParameters();
+                //ClearMenuSPUParameters();
+                if (parent)
+                    parent->HideDVDButton(true);
+
                 ClearSubtitlesOSD();
 
                 if (IsInMenu())
@@ -446,6 +460,8 @@
                             break;
                     }
                 }
+                
+                audioStreamsChanged = true;
 
                 if (blockBuf != dvdBlockWriteBuf)
                 {
@@ -536,18 +552,13 @@
                         .arg(hl->pts).arg(hl->buttonN));
 
                 menuBtnLock.lock();
-
-                if (DVDButtonUpdate(false))
-                {
-                    ClearMenuButton();
-                    buttonExists = DrawMenuButton(menuSpuPkt,menuBuflength);
-                }
-
-                menuBtnLock.unlock();
-
+                
+                DVDButtonUpdate(false);
                 ClearSubtitlesOSD();
-
-                if (parent && buttonExists && NumMenuButtons() > 0)
+                
+                menuBtnLock.unlock();
+                
+                if (parent && buttonExists)
                     parent->HideDVDButton(false);
 
                 if (blockBuf != dvdBlockWriteBuf)
@@ -656,6 +667,24 @@
     return cellStart / 90000;
 }
 
+/** \brief check if dvd cell has changed
+ */
+bool DVDRingBufferPriv::CellChanged(void)
+{
+    bool ret = cellChanged;
+    cellChanged = false;
+    return ret;
+}
+
+/** \brief check if pgc length has changed
+ */
+bool DVDRingBufferPriv::PGCLengthChanged(void)
+{
+    bool ret = pgcLengthChanged;
+    pgcLengthChanged = false;
+    return ret;
+}
+
 void DVDRingBufferPriv::SkipStillFrame(void)
 {
     QMutexLocker locker(&seekLock);
@@ -687,12 +716,16 @@
     }
     else if (str.compare("menu") == 0)
     {
+        dvdnav_status_t rootMenuSupported =
+            dvdnav_menu_supported(dvdnav, DVD_MENU_Root);
         dvdnav_status_t titleMenuSupported =
             dvdnav_menu_supported(dvdnav, DVD_MENU_Title);
-        if (titleMenuSupported == DVDNAV_STATUS_OK)
+        if (rootMenuSupported == DVDNAV_STATUS_OK)
+            menuid = DVD_MENU_Root;
+        else if (titleMenuSupported == DVDNAV_STATUS_OK)
             menuid = DVD_MENU_Title;
         else
-            menuid = DVD_MENU_Root;
+            return false;
     }
     else
         return false;
@@ -720,7 +753,7 @@
 
 void DVDRingBufferPriv::MoveButtonLeft(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0))
+    if (NumMenuButtons() > 1)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_left_button_select(dvdnav, pci);
@@ -729,7 +762,7 @@
 
 void DVDRingBufferPriv::MoveButtonRight(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0) )
+    if (NumMenuButtons() > 1)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_right_button_select(dvdnav, pci);
@@ -738,7 +771,7 @@
 
 void DVDRingBufferPriv::MoveButtonUp(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0))
+    if (NumMenuButtons() > 1)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_upper_button_select(dvdnav, pci);
@@ -747,7 +780,7 @@
 
 void DVDRingBufferPriv::MoveButtonDown(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0))
+    if (NumMenuButtons() > 1)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_lower_button_select(dvdnav, pci);
@@ -758,7 +791,7 @@
  */
 void DVDRingBufferPriv::ActivateButton(void)
 {
-    if (IsInMenu() && (NumMenuButtons() > 0))
+    if (NumMenuButtons() > 0)
     {
         pci_t *pci = dvdnav_get_current_nav_pci(dvdnav);
         dvdnav_button_activate(dvdnav, pci);
@@ -788,22 +821,27 @@
         SelectDefaultButton();
         buttonSelected = true;
     }
+
     if (DVDButtonUpdate(false))
-        buttonExists = DrawMenuButton(menuSpuPkt,menuBuflength);
+    {
+        int32_t gotbutton;
+        buttonExists = DecodeSubtitles(&dvdMenuButton, &gotbutton, 
+                                        menuSpuPkt, menuBuflength);
+    }
 }
 
-/** \brief returns dvd menu button if available.
+/** \brief returns dvd menu button information if available.
  * used by NVP::DisplayDVDButton
  */
-AVSubtitleRect *DVDRingBufferPriv::GetMenuButton(void)
+AVSubtitle *DVDRingBufferPriv::GetMenuSubtitle(void)
 {
     menuBtnLock.lock();
 
     if ((menuBuflength > 4) && buttonExists &&
-        (dvdMenuButton.rects[0].h >= hl_height) && 
-        (dvdMenuButton.rects[0].w >= hl_width))
+        (dvdMenuButton.rects[0].h >= hl_button.height()) && 
+        (dvdMenuButton.rects[0].w >= hl_button.width()))
     {
-        return &(dvdMenuButton.rects[0]);
+        return &(dvdMenuButton);
     }
 
     return NULL;
@@ -815,27 +853,25 @@
     menuBtnLock.unlock();
 }
 
-/** \brief obtain dvd menu button bitmap, alpha and color palette
+/** \brief get coordinates of highlighted button
  */
-bool DVDRingBufferPriv::DrawMenuButton(uint8_t *spu_pkt, int buf_size)
+QRect DVDRingBufferPriv::GetButtonCoords(void)
 {
-    int gotbutton;
-    if (DecodeSubtitles(&dvdMenuButton, &gotbutton, spu_pkt, buf_size))
-    {
-        int x1, y1;
-        x1 = dvdMenuButton.rects[0].x;
-        y1 = dvdMenuButton.rects[0].y;
-        if (hl_startx > x1)
-            dvdMenuButton.rects[0].x = hl_startx - x1;
-        else
-            dvdMenuButton.rects[0].x = 0;
-        if (hl_starty > y1)
-            dvdMenuButton.rects[0].y  = hl_starty - y1;
-        else
-            dvdMenuButton.rects[0].y = 0;
-        return true;
-    }
-    return false;
+    QRect rect(0,0,0,0);
+    if (!buttonExists)
+        return rect;
+
+    int x1, y1;
+    int x = 0; int y = 0;
+    x1 = dvdMenuButton.rects[0].x;
+    y1 = dvdMenuButton.rects[0].y;
+    if (hl_button.x() > x1)
+        x = hl_button.x() - x1;
+    if (hl_button.y() > y1)
+        y  = hl_button.y() - y1;
+    rect.setRect(x, y, hl_button.width(), hl_button.height());    
+    
+    return rect;
 }
 
 /** \brief generate dvd subtitle bitmap or dvd menu bitmap. 
@@ -891,13 +927,11 @@
                 {
                     if ((buf_size - pos) < 2)
                         goto fail;
-                    if (!IsInMenu())
-                    {
-                        palette[3] = spu_pkt[pos] >> 4;
-                        palette[2] = spu_pkt[pos] & 0x0f;
-                        palette[1] = spu_pkt[pos + 1] >> 4;
-                        palette[0] = spu_pkt[pos + 1] & 0x0f;
-                    }
+                    
+                    palette[3] = spu_pkt[pos] >> 4;
+                    palette[2] = spu_pkt[pos] & 0x0f;
+                    palette[1] = spu_pkt[pos + 1] >> 4;
+                    palette[0] = spu_pkt[pos + 1] & 0x0f;
                     pos +=2;
                 }
                 break;
@@ -905,13 +939,10 @@
                 {
                     if ((buf_size - pos) < 2)
                         goto fail;
-                    if (!IsInMenu())
-                    {
-                        alpha[3] = spu_pkt[pos] >> 4;
-                        alpha[2] = spu_pkt[pos] & 0x0f;
-                        alpha[1] = spu_pkt[pos + 1] >> 4;
-                        alpha[0] = spu_pkt[pos + 1] & 0x0f;
-                    }
+                    alpha[3] = spu_pkt[pos] >> 4;
+                    alpha[2] = spu_pkt[pos] & 0x0f;
+                    alpha[1] = spu_pkt[pos + 1] >> 4;
+                    alpha[0] = spu_pkt[pos + 1] & 0x0f;
                     pos +=2;
                 }
                 break;
@@ -948,19 +979,11 @@
             w = x2 - x1 + 1;
             if (w < 0)
                 w = 0;
-            h = y2 - y1;
+            h = y2 - y1 + 2;
             if (h < 0)
                 h = 0;
             if (w > 0 && h > 0) 
             {
-                if (IsInMenu())
-                {
-                    for (int i = 0; i < 4 ; i++)
-                    {
-                        alpha[i]   = button_alpha[i];
-                        palette[i] = button_color[i];
-                    }
-                }
                 if (sub->rects != NULL)
                 {
                     for (i = 0; i < sub->num_rects; i++)
@@ -973,8 +996,9 @@
                 }
 
                 bitmap = (uint8_t*) av_malloc(w * h);
-                sub->rects = (AVSubtitleRect *)av_mallocz(sizeof(AVSubtitleRect));
-                sub->num_rects = 1;
+                sub->num_rects = (NumMenuButtons() > 0) ? 2 : 1;
+                sub->rects = (AVSubtitleRect *)
+                        av_mallocz(sizeof(AVSubtitleRect) * sub->num_rects);
                 sub->rects[0].rgba_palette = (uint32_t*)av_malloc(4 *4);
                 decode_rle(bitmap, w * 2, w, (h + 1) / 2,
                             spu_pkt, offset1 * 2, buf_size);
@@ -988,7 +1012,13 @@
                 sub->rects[0].h = h;
                 sub->rects[0].nb_colors = 4;
                 sub->rects[0].linesize = w;
-                if (!IsInMenu())
+                if (NumMenuButtons() > 0)
+                {
+                    sub->rects[1].rgba_palette = (uint32_t*)av_malloc(4 *4);
+                    guess_palette(sub->rects[1].rgba_palette, 
+                                button_color, button_alpha);
+                }
+                else
                     find_smallest_bounding_rectangle(sub);
                 *gotSubtitles = 1;
             }
@@ -1036,27 +1066,13 @@
     if (dvdRet == DVDNAV_STATUS_ERR)
         return false;
 
-    bool button_is_transparent = true;
-
     for (uint i = 0 ; i < 4 ; i++)
     {
         button_alpha[i] = 0xf & (hl.palette >> (4 * i ));
-        if (button_alpha[i] > 0)
-            button_is_transparent = false;
         button_color[i] = 0xf & (hl.palette >> (16+4 *i ));
     }
 
-    if (button_is_transparent)
-    {
-        for (uint i = 0; i < 4; i++)
-            button_alpha[i] = 10;
-    }
-
-
-    hl_startx = hl.sx;
-    hl_width = hl.ex - hl.sx;
-    hl_starty = hl.sy;
-    hl_height  = hl.ey - hl.sy;
+    hl_button.setCoords(hl.sx, hl.sy, hl.ex, hl.ey);
 
     if (((hl.sx + hl.sy) > 0) && 
             (hl.sx < videowidth && hl.sy < videoheight))
@@ -1071,10 +1087,13 @@
 {
     if (buttonExists || dvdMenuButton.rects)
     {
-        av_free(dvdMenuButton.rects[0].rgba_palette);
-        av_free(dvdMenuButton.rects[0].bitmap);
+        for (uint i = 0; i < dvdMenuButton.num_rects; i++)
+        {
+            AVSubtitleRect* rect =  &(dvdMenuButton.rects[i]);
+            av_free(rect->rgba_palette);
+            av_free(rect->bitmap);
+        }
         av_free(dvdMenuButton.rects);
-
         dvdMenuButton.rects = NULL;
         dvdMenuButton.num_rects = 0;
         buttonExists = false;
@@ -1095,8 +1114,7 @@
 
     av_free(menuSpuPkt);
     menuBuflength = 0;
-    hl_startx = hl_starty = 0;
-    hl_width = hl_height = 0;
+    hl_button.setRect(0, 0, 0, 0);
 }
 
 int DVDRingBufferPriv::NumMenuButtons(void) const
@@ -1289,13 +1307,33 @@
     return false;
 }
 
+/** \brief Run SeekCellStart its okay to run seekcellstart
+ ** ffmpeg for some reason doesnt' output menu spu if seekcellstart
+ ** is started too soon after a video codec/resolution change
+ */
+void DVDRingBufferPriv::RunSeekCellStart(void)
+{
+    if (!runSeekCellStart)
+        return;
+    
+    bool ret = true;
+    if (NumMenuButtons() > 0 && !buttonExists)
+        ret = false;
+    
+    if (ret) 
+    {
+        ret = SeekCellStart();
+        runSeekCellStart = false;
+    }
+}
+
 /** \brief seek the beginning of a dvd cell
  */
-void DVDRingBufferPriv::SeekCellStart(void)
+bool DVDRingBufferPriv::SeekCellStart(void)
 {
     QMutexLocker lock(&seekLock);
-    gotoCellStart = true;
-    Seek(cellStart);
+    runningCellStart = true;
+    return (Seek(cellStart) == 0);
 }
 
 /** \brief set dvd speed. uses the DVDDriveSpeed Setting from the settings 
diff -uNr mythtv-0.21/libs/libmythtv/DVDRingBuffer.h mythtv/libs/libmythtv/DVDRingBuffer.h
--- mythtv-0.21/libs/libmythtv/DVDRingBuffer.h	2007-09-06 18:56:45.000000000 +0200
+++ mythtv/libs/libmythtv/DVDRingBuffer.h	2008-05-12 05:08:03.000000000 +0200
@@ -41,21 +41,21 @@
     void GetPartAndTitle(int &_part, int &_title) const
         { _part  = part; _title = title; }
     uint GetTotalTimeOfTitle(void);
-    uint GetChapterLength(void) { return pgLength / 90000; }
+    uint GetChapterLength(void) const { return pgLength / 90000; }
     uint GetCellStart(void);
-    bool InStillFrame(void) { return cellHasStillFrame; }
-    bool IsWaiting(void) { return dvdWaiting; }
-    int  NumPartsInTitle(void) { return titleParts; }
+    bool PGCLengthChanged(void);
+    bool CellChanged(void);
+    bool InStillFrame(void) const { return cellHasStillFrame; }
+    bool AudioStreamsChanged(void) const { return audioStreamsChanged; }
+    bool IsWaiting(void) const { return dvdWaiting; }
+    int  NumPartsInTitle(void) const { return titleParts; }
     void GetMenuSPUPkt(uint8_t *buf, int len, int stream_id);
 
-    AVSubtitleRect *GetMenuButton(void);
+    QRect GetButtonCoords(void);
+    AVSubtitle *GetMenuSubtitle(void);
     void ReleaseMenuButton(void);
 
     bool IgnoringStillorWait(void) { return skipstillorwait; }
-    uint ButtonPosX(void)   { return hl_startx; }
-    uint ButtonPosY(void)   { return hl_starty; }
-    uint ButtonWidth(void)  { return hl_width; }
-    uint ButtonHeight(void) { return hl_height; }
     uint GetAudioLanguage(int id);
     int  GetSubTrackNum(uint key);
     int  GetAudioTrackNum(uint key);
@@ -74,6 +74,7 @@
     int GetCellID(void) { return cellid; }
     int GetVobID(void)  { return vobid; }
     bool IsSameChapter(int tmpcellid, int tmpvobid);
+    void RunSeekCellStart(void);
 
     // commands
     bool OpenFile(const QString &filename);
@@ -97,15 +98,16 @@
     int NumMenuButtons(void) const;
     void IgnoreStillOrWait(bool skip) { skipstillorwait = skip; }
     void InStillFrame(bool change) { cellHasStillFrame = change; }
+    void AudioStreamsChanged(bool change) { audioStreamsChanged = change; }
     uint GetCurrentTime(void) { return (currentTime / 90000); }
     uint TitleTimeLeft(void);
     void  SetTrack(uint type, int trackNo);
     int   GetTrack(uint type);
     uint8_t GetNumAudioChannels(int id);
     void JumpToTitle(bool change) { jumptotitle = change; }
-    void SeekCellStart(void);
     void SetDVDSpeed(void);
     void SetDVDSpeed(int speed);
+    void SetRunSeekCellStart(bool change) { runSeekCellStart = change; }
 
     void SetParent(NuppelVideoPlayer *p) { parent = p; }
 
@@ -120,6 +122,8 @@
     long long      pgLength;
     long long      pgcLength;
     long long      cellStart;
+    bool           cellChanged;
+    bool           pgcLengthChanged;
     long long      pgStart;
     long long      currentpos;
     dvdnav_t      *lastNav; // This really belongs in the player.
@@ -129,19 +133,16 @@
     bool           gotStop;
 
     bool           cellHasStillFrame;
+    bool           audioStreamsChanged;
     bool           dvdWaiting;
     long long      titleLength;
     MythTimer      stillFrameTimer;
     uint32_t       clut[16];
     uint8_t        button_color[4];
     uint8_t        button_alpha[4];
-    uint16_t       hl_startx;
-    uint16_t       hl_width;
-    uint16_t       hl_starty;
-    uint16_t       hl_height;
+    QRect          hl_button;
     uint8_t       *menuSpuPkt;
     int            menuBuflength;
-    uint8_t       *buttonBitmap;
     AVSubtitle     dvdMenuButton;
     bool           skipstillorwait;
     long long      cellstartPos;
@@ -153,7 +154,8 @@
     int            lastvobid;
     bool           cellRepeated;
     int            buttonstreamid;
-    bool           gotoCellStart;
+    bool           runningCellStart;
+    bool           runSeekCellStart;
     long long      menupktpts;
     int            curAudioTrack;
     int8_t         curSubtitleTrack;
@@ -177,7 +179,6 @@
     QMutex seekLock;
 
     long long Seek(long long time);
-    bool DrawMenuButton(uint8_t *spu_pkt, int buf_size);
     bool DVDButtonUpdate(bool b_mode);
     void ClearMenuSPUParameters(void);
     void ClearMenuButton(void);
@@ -185,6 +186,7 @@
     uint ConvertLangCode(uint16_t code);
     void SelectDefaultButton(void);
     void ClearSubtitlesOSD(void);
+    bool SeekCellStart(void);
 
     int get_nibble(const uint8_t *buf, int nibble_offset);
     int decode_rle(uint8_t *bitmap, int linesize, int w, int h,
diff -uNr mythtv-0.21/libs/libmythtv/eithelper.cpp mythtv/libs/libmythtv/eithelper.cpp
--- mythtv-0.21/libs/libmythtv/eithelper.cpp	2008-03-04 00:05:20.000000000 +0100
+++ mythtv/libs/libmythtv/eithelper.cpp	2008-06-20 12:11:26.000000000 +0200
@@ -693,6 +693,20 @@
 
     // United Kingdom
     fix[ 9018U << 16] = EITFixUp::kFixUK;
+    // UK Freesat
+    fix[ 2013LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2041LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2042LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2044LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2045LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2046LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2047LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2048LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2049LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2050LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2051LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2053LL << 32 | 2U << 16] = EITFixUp::kFixUK;
+    fix[ 2054LL << 32 | 2U << 16] = EITFixUp::kFixUK;
 
     // ComHem Sweeden
     fix[40999U << 16       ] = EITFixUp::kFixComHem;
@@ -814,13 +828,12 @@
         EITFixUp::kEFixForceISO8859_15;
     // On transport 10008 only following channels need fixing:
     fix[    10008LL<<32 | 61441U << 16 | 53002] = // Tele 5
-        fix[10008LL<<32 | 61441U << 16 | 53630] = // HSE24
         EITFixUp::kEFixForceISO8859_15;
 
     // DVB-S Astra 19.2E DMAX Germany
     fix[  1113LL << 32 | 1 << 16 | 12602] = EITFixUp::kEFixForceISO8859_15;
 
-    // Premiere and Pro7/Sat.1
+    // Premiere
     fix[133 << 16] = EITFixUp::kEFixForceISO8859_15;
 
     // DVB-T Spain
@@ -829,6 +842,18 @@
         fix[   13LL << 32 | 8916 << 16 ] = // national multiplex
         fix[ 6200LL << 32 | 8916 << 16 ] = // Madrid (TeleMadrid)
         EITFixUp::kEFixForceISO8859_15;
+
+    // DVB-S Astra 19.2E french channels
+    fix[     1022LL << 32 | 1 << 16 |  6901 ] = // DIRECT 8
+        fix[ 1022LL << 32 | 1 << 16 |  6905 ] = // France 24 (en Francais)
+        fix[ 1022LL << 32 | 1 << 16 |  6911 ] = // DIRECT 8
+        fix[ 1072LL << 32 | 1 << 16 |  8201 ] = // CANAL+
+        fix[ 1070LL << 32 | 1 << 16 |  8004 ] = // EURONEWS
+        fix[ 1091LL << 32 | 1 << 16 | 31220 ] = // EuroNews
+        fix[ 1094LL << 32 | 1 << 16 | 17027 ] = // LCP
+        fix[ 1094LL << 32 | 1 << 16 | 17028 ] = // NT1
+        fix[ 1100LL << 32 | 1 << 16 |  8710 ] = // NRJ 12
+        EITFixUp::kEFixForceISO8859_15;
 }
 
 static int calc_eit_utc_offset(void)
diff -uNr mythtv-0.21/libs/libmythtv/firewiredevice.cpp mythtv/libs/libmythtv/firewiredevice.cpp
--- mythtv-0.21/libs/libmythtv/firewiredevice.cpp	2008-03-04 18:43:47.000000000 +0100
+++ mythtv/libs/libmythtv/firewiredevice.cpp	2008-04-28 01:44:01.000000000 +0200
@@ -224,8 +224,11 @@
         return true;
     }
 
+    // the PACE is obviously not a Motorola channel changer, but the
+    // same commands work for it as the Motorola.
     bool is_mot = ((panel_model.upper().left(4) == "DCT-") ||
-                   (panel_model.upper().left(4) == "DCH-"));
+                   (panel_model.upper().left(4) == "DCH-") ||
+                   (panel_model.upper().left(4) == "PACE-"));
 
     if (is_mot && !alt_method)
     {
@@ -444,6 +447,21 @@
         id_to_model[motorola_vendor_ids[i] << 32 | 0x64cb] = "DCT-6212";
         id_to_model[motorola_vendor_ids[i] << 32 | 0x646b] = "DCT-6216";
     }
+
+    const uint64_t pace_vendor_ids[] =
+    {
+        /* PACE 550-HD & 779 */
+        0x5094,
+    };
+
+    const uint pace_vendor_id_cnt =
+        sizeof(pace_vendor_ids) / sizeof(uint64_t);
+
+    for (uint i = 0; i < pace_vendor_id_cnt; i++)
+    {
+        id_to_model[pace_vendor_ids[i] << 32 | 0x10551] = "PACE-550";
+        id_to_model[pace_vendor_ids[i] << 32 | 0x10755] = "PACE-779";
+    }
 }
 
 bool FirewireDevice::IsSTBSupported(const QString &panel_model)
@@ -458,6 +476,8 @@
             (model == "SA3250HD") ||
             (model == "SA4200HD") ||
             (model == "SA4250HDC") ||
+            (model == "PACE-550") ||
+            (model == "PACE-779") ||
             (model == "GENERIC"));
 }
 
diff -uNr mythtv-0.21/libs/libmythtv/frequencytables.cpp mythtv/libs/libmythtv/frequencytables.cpp
--- mythtv-0.21/libs/libmythtv/frequencytables.cpp	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmythtv/frequencytables.cpp	2008-04-14 23:34:25.000000000 +0200
@@ -320,6 +320,15 @@
         DTVGuardInterval::kGuardIntervalAuto, DTVHierarchy::kHierarchyNone,
         DTVModulation::kModulationQAMAuto, 125000, 0); // UHF 21-69
 
+    // New Zealand
+    fmap["dvbt_ofdm_nz0"] = new FrequencyTable(
+        474000000, 858000000, 8000000, "", 0, DTVInversion::kInversionOff,
+        DTVBandwidth::kBandwidth8MHz, DTVCodeRate::kFEC_3_4,
+        DTVCodeRate::kFEC_3_4, DTVModulation::kModulationQAM64,
+        DTVTransmitMode::kTransmissionMode8K,
+        DTVGuardInterval::kGuardInterval_1_16, DTVHierarchy::kHierarchyNone,
+        DTVModulation::kModulationQAM64, 0 , 0); // UHF 21-69
+
 //#define DEBUG_DVB_OFFSETS
 #ifdef DEBUG_DVB_OFFSETS
     // UHF 14-69
diff -uNr mythtv-0.21/libs/libmythtv/importicons.cpp mythtv/libs/libmythtv/importicons.cpp
--- mythtv-0.21/libs/libmythtv/importicons.cpp	2008-01-29 00:31:10.000000000 +0100
+++ mythtv/libs/libmythtv/importicons.cpp	2008-05-28 02:19:25.000000000 +0200
@@ -123,9 +123,9 @@
     {
         case STATE_NORMAL:
             if (m_editManual->getValue())
-                 m_buttonManual->setEnabled(true);
+                m_buttonManual->setEnabled(true);
             else
-            m_buttonManual->setEnabled(false);
+                m_buttonManual->setEnabled(false);
             if (m_missingCount < m_missingMaxCount)
             {
                 if (m_missingMaxCount < 2) //When there's only one icon, nothing to skip to!
@@ -210,7 +210,7 @@
                             arg(escape_csv(entry2.strServiceId));
 
     if ((!isBlocked(m_strMatches)) &&
-            (checkAndDownload(entry.strLogo)))
+            (checkAndDownload(entry.strLogo, entry2.strChanId)))
     {
 
         if (m_missingMaxCount > 1)
@@ -453,7 +453,7 @@
     return str;
 }
 
-bool ImportIconsWizard::checkAndDownload(const QString& str)
+bool ImportIconsWizard::checkAndDownload(const QString& str, const QString& localChanId)
 {
     // Do not try and access dialog within this function
 
@@ -481,7 +481,7 @@
 
         query.prepare(qstr);
         query.bindValue(":ICON", m_strChannelDir+str2);
-        query.bindValue(":CHANID", (*m_iter).strChanId);
+        query.bindValue(":CHANID", localChanId);
 
         if (!query.exec())
         {
@@ -572,6 +572,9 @@
         VERBOSE(VB_CHANNEL, QString("Icon Import: Working search : %1").arg(str));
         QStringList strSplit=QStringList::split("\n",str);
 
+        QString prevIconName = "";
+        int namei = 1;
+
         for (QStringList::iterator begin=strSplit.begin();
              begin!=strSplit.end();begin++)
         {
@@ -584,7 +587,19 @@
                 entry.strName=ret[1];
                 entry.strLogo=ret[2];
                 m_listSearch.append(entry);
-                m_listIcons->addSelection(entry.strName);
+                if (prevIconName == entry.strName)
+                {
+                    QString newname = QString("%1 (%2)").arg(entry.strName)
+                                                        .arg(namei);
+                    m_listIcons->addSelection(newname);
+                    namei++;
+                }
+                else
+                {
+                    m_listIcons->addSelection(entry.strName);
+                    namei=1;
+                }
+                prevIconName = entry.strName;
             }
         }
         retVal=true;
@@ -617,7 +632,7 @@
             {
                 QStringList ret = extract_csv(*begin);
                 VERBOSE(VB_CHANNEL, QString("Icon Import: findmissing : %1 %2 %3 %4 %5").arg(ret[0]).arg(ret[1]).arg(ret[2]).arg(ret[3]).arg(ret[4]));
-                checkAndDownload(ret[4]);
+                checkAndDownload(ret[4], (*m_iter).strChanId);
             }
         }
         return true;
diff -uNr mythtv-0.21/libs/libmythtv/importicons.h mythtv/libs/libmythtv/importicons.h
--- mythtv-0.21/libs/libmythtv/importicons.h	2008-01-03 21:00:00.000000000 +0100
+++ mythtv/libs/libmythtv/importicons.h	2008-05-20 13:00:46.000000000 +0200
@@ -145,9 +145,10 @@
     /*! \brief checks and attempts to download the logo file to the appropriate
      *   place
      * \param str the string of the downloaded url
+     * \param localChanId the local ID number of the channel
      * \return true/false
      */
-    bool checkAndDownload(const QString& str);
+    bool checkAndDownload(const QString& str, const QString& localChanId);
 
     /*! \brief attempt the inital load of the TV channel information
      * \return the number of TV channels
diff -uNr mythtv-0.21/libs/libmythtv/inputinfo.cpp mythtv/libs/libmythtv/inputinfo.cpp
--- mythtv-0.21/libs/libmythtv/inputinfo.cpp	2008-01-14 16:22:34.000000000 +0100
+++ mythtv/libs/libmythtv/inputinfo.cpp	2008-05-04 20:33:20.000000000 +0200
@@ -46,6 +46,9 @@
 bool InputInfo::FromStringList(QStringList::const_iterator &it,
                                QStringList::const_iterator end)
 {
+    if (it == end)
+        return false;
+
     name     = QDeepCopy<QString>(*it);
     name     = (name == "<EMPTY>") ? QString::null : name;
     NEXT();
diff -uNr mythtv-0.21/libs/libmythtv/jobqueue.cpp mythtv/libs/libmythtv/jobqueue.cpp
--- mythtv-0.21/libs/libmythtv/jobqueue.cpp	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmythtv/jobqueue.cpp	2008-04-04 13:40:43.000000000 +0200
@@ -1249,7 +1249,7 @@
                       "j.args, j.comment, r.endtime, j.schedruntime "
                   "FROM jobqueue j, recorded r "
                   "WHERE j.chanid = r.chanid AND j.starttime = r.starttime "
-                  "ORDER BY j.inserttime, j.chanid, j.id;");
+                  "ORDER BY j.schedruntime, j.id;");
 
     if (!query.exec() || !query.isActive())
     {
diff -uNr mythtv-0.21/libs/libmythtv/jobqueue.h mythtv/libs/libmythtv/jobqueue.h
--- mythtv-0.21/libs/libmythtv/jobqueue.h	2007-12-03 07:07:52.000000000 +0100
+++ mythtv/libs/libmythtv/jobqueue.h	2008-07-12 04:18:55.000000000 +0200
@@ -108,7 +108,7 @@
                          QDateTime starttime, QString args = "",
                          QString comment = "", QString host = "",
                          int flags = 0, int status = JOB_QUEUED,
-                         QDateTime schedruntime = QDateTime::QDateTime());
+                         QDateTime schedruntime = QDateTime());
 
     static bool QueueJobs(int jobTypes, QString chanid,
                          QDateTime starttime, QString args = "",
